//
// ImpBrush.cpp
//
// The implementation of virtual brush. All the other brushes inherit from it
//

#include "impressionistDoc.h"

#include "ImpBrush.h"

int ImpBrush::c_nBrushCount = 0;
ImpBrush** ImpBrush::c_pBrushes = NULL;

ImpBrush::ImpBrush( ImpressionistDoc* pDoc, char* name ) :
	m_pDoc(pDoc), m_pBrushName(name)
{
}

//--------------------------------------------------------
// ImpressionistDoc ImpBrush::GetDocument
// return m_pDoc which connect the UI and brushes
//--------------------------------------------------------
ImpressionistDoc* ImpBrush::GetDocument( void )
{
	// connect the brush type with the UI
	return m_pDoc;
}

//--------------------------------------------------------
// void ImpBrush::BrushName
// not use in this version
//--------------------------------------------------------

char* ImpBrush::BrushName( void )
{
	return m_pBrushName;
}

//--------------------------------------------------------
// void ImpBrush::SetColor( Point source)
// source : the coord at the original window to sample to the color from
//--------------------------------------------------------

void ImpBrush::SetColor ( Point source )
{

	ImpressionistDoc* pDoc = GetDocument();

	GLubyte color[3];
	memcpy ( color, pDoc->GetOriginalPixel( source ), 3 );
	glColor3ubv( color );
}