// generated by Fast Light User Interface Designer (fluid) version 1.00

#include "baseUI.h"

Fl_Menu_Item BaseUI::menu_items[] = {
 {"File", 0,  0, 0, 64, 4, 0, 14, 0},
 {"LoadImage", 0x8006c,  (Fl_Callback*)cb_load_image, 0, 0, 0, 0, 14, 0},
 {"SaveImage", 0x80073,  (Fl_Callback*)cb_save_image, 0, 4, 0, 0, 14, 0},
 {"Brushes", 0x80062,  (Fl_Callback*)cb_brushes, 0, 132, 0, 0, 14, 0},
 {"Exit", 0x80065,  (Fl_Callback*)cb_exit, 0, 0, 0, 0, 14, 0},
 {0},
 {"Help", 0,  0, 0, 64, 4, 0, 14, 0},
 {"About", 0x80061,  (Fl_Callback*)cb_about, 0, 0, 0, 0, 14, 0},
 {0},
 {0}
};

Fl_Menu_Item BaseUI::menu_Brush[] = {
 {"Points", 0x80070,  (Fl_Callback*)cb_brushChoice, (void*)(BRUSH_POINTS), 0, 0, 0, 14, 0},
 {"Lines", 0,  (Fl_Callback*)cb_brushChoice, (void*)(BRUSH_LINES), 0, 0, 0, 14, 0},
 {"Circles", 0,  (Fl_Callback*)cb_brushChoice, (void*)(BRUSH_CIRCLES), 0, 0, 0, 14, 0},
 {"Scattered Points", 0,  (Fl_Callback*)cb_brushChoice, (void*)(BRUSH_SCATTERED_POINTS), 0, 0, 0, 14, 0},
 {"Scattered Lines", 0,  (Fl_Callback*)cb_brushChoice, (void*)(BRUSH_SCATTERED_LINES), 0, 0, 0, 14, 0},
 {"Scattered Circles", 0,  (Fl_Callback*)cb_brushChoice, (void*)(BRUSH_SCATTERED_CIRCLES), 0, 0, 0, 14, 0},
 {0}
};
class impressionistDoc;

BaseUI::BaseUI() {
  Fl_Window* w;
  m_nSize = 10;
  { Fl_Window* o = m_mainWindow = new Fl_Window(600, 300);
    w = o;
    o->callback((Fl_Callback*)cb_exit2, (void*)(this));
    { Fl_Menu_Bar* o = items = new Fl_Menu_Bar(0, 0, 600, 25, "Menus");
      o->down_box(FL_FLAT_BOX);
      o->labeltype(FL_NO_LABEL);
      o->align(69);
      o->menu(menu_items);
    }
    { Fl_Group* o = group = new Fl_Group(0, 25, 600, 275);
      m_paintView = new PaintView(0, 25, 300, 275, "This is the paint view");      m_paintView->box(FL_DOWN_FRAME);
      m_origView = new OriginalView(300, 25, 300, 275, "This is the orig view");
      m_origView->box(FL_DOWN_FRAME);
      m_origView->deactivate();
      o->end();
      Fl_Group::current()->resizable(o);
    }
    o->end();
  }
  { Fl_Window* o = m_brushDialog = new Fl_Window(286, 100);
    w = o;
    o->user_data((void*)(this));
    { Fl_Value_Slider* o = m_BrushSizeSlider = new Fl_Value_Slider(15, 55, 155, 25);
      o->type(1);
      o->labelfont(4);
      o->labelsize(12);
      o->maximum(20);
      o->step(1);
      o->callback((Fl_Callback*)cb_sizeSlides, (void*)(this));
      m_BrushSizeSlider->value(m_nSize);
      m_BrushSizeSlider->align(FL_ALIGN_RIGHT);
    }
    { Fl_Choice* o = new Fl_Choice(55, 15, 115, 25, "Brush");
      o->callback((Fl_Callback*)cb_brushChoice, (void*)(this));
      o->when(FL_WHEN_CHANGED);
      o->menu(menu_Brush);
    }
    o->end();
  }
}

int BaseUI::getSize(void) {
  return m_nSize;
}

void BaseUI::resize_windows(int w, int h) {
  m_paintView->size(w,h);
m_origView->size(w,h);
}

ImpressionistDoc* BaseUI::getDocument() {
  return m_pDoc;
}

void BaseUI::setDocument(ImpressionistDoc* doc) {
  m_pDoc = doc;
m_origView->m_pDoc = doc;
m_paintView->m_pDoc = doc;
}

void BaseUI::show() {
  m_mainWindow->show();
	m_paintView->show();
	m_origView->show();
}

BaseUI* BaseUI::whoami(Fl_Menu_* o) {
  return ( (BaseUI*)(o->parent()->user_data()) );
}

void BaseUI::cb_sizeSlides(Fl_Widget* o, void* v) {
  ((BaseUI*)(o->user_data()))->m_nSize =
 	int( ((Fl_Slider *)o)->value() ) ;
}

void BaseUI::cb_brushes(Fl_Menu_* o, void* v) {
  whoami(o)->m_brushDialog->show();
}

void BaseUI::cb_brushChoice(Fl_Widget* o, void* v) {
  ImpressionistDoc *pDoc = 
	((BaseUI *)(o->user_data()))->getDocument();
	pDoc->setBrushType((int)v);
}

void BaseUI::cb_exit2(Fl_Widget* o, void* v) {
  BaseUI* pUI = (BaseUI*)(o->user_data());
	pUI->m_mainWindow->hide();
	pUI->m_brushDialog->hide();
}

void BaseUI::cb_load_image(Fl_Menu_* o, void* v) {
  ImpressionistDoc *pDoc = 
	whoami((Fl_Menu_*) o)->getDocument();
	char* newfile = fl_file_chooser("Open File?", "*.bmp", pDoc->getImageName() );
	if (newfile != NULL) {
		pDoc->loadImage(newfile);
	}
}

void BaseUI::cb_save_image(Fl_Menu_* o, void* v) {
  ImpressionistDoc *pDoc =
	whoami(o)->getDocument();
	char* newfile = fl_file_chooser("Save File?", "*.bmp", "save.bmp" );
	if (newfile != NULL) {
		pDoc->saveImage(newfile);
	}
}

void BaseUI::cb_exit(Fl_Menu_* o, void* v) {
  whoami(o)->m_mainWindow->hide();
whoami(o)->m_brushDialog->hide();
}

void BaseUI::cb_about(Fl_Menu_* o, void* v) {
  fl_message("Impressionist FLTK version for CSE457, Spring 2000");
}
