//
// DotBrush.cpp
//
// The implementation of Point Brush. It is a kind of ImpBrush. All your brush implementations
// will look like the file with the different GL primitive calls.
//

#include "impressionistDoc.h"
#include "dotbrush.h"

DotBrush::DotBrush( ImpressionistDoc* pDoc, char* name ) :
	ImpBrush(pDoc,name)
{
}

//--------------------------------------------------------
// void DotBrush::BrushBegin( Point source, Point target )
// source : the coord at the original window to sample to the color from
// target : the coordinate at the paint window
//--------------------------------------------------------

void DotBrush::BrushBegin( Point source, Point target )
{
	// get the pDoc which will enable access to the UI
	ImpressionistDoc* pDoc = GetDocument();

	// first get the size of the brush
	int size = pDoc->getSize();

	// set it in openGL
	glPointSize( (float)size );

	BrushMove( source, target );
}

//--------------------------------------------------------
// void DotBrush::BrushMove( Point source, Point target )
//
//--------------------------------------------------------

void DotBrush::BrushMove( Point source, Point target )
{
	ImpressionistDoc* pDoc = GetDocument();

	if ( pDoc == NULL ) {
		printf( "DotBrush::BrushMove  document is NULL\n" );
		return;
	}

	glBegin( GL_POINTS );			
		SetColor( source );					// set the color
		glVertex2d( target.x, target.y );	
	glEnd();
	glFlush();		
}

//--------------------------------------------------------
// void DotBrush::BrushEnd( Point source, Point target )
//
// 
//--------------------------------------------------------

void DotBrush::BrushEnd( Point source, Point target )
{
	// do nothing so far
}

