// 
// impressionistDoc.h
//
// header file for Doc 
//

#ifndef ImpressionistDoc_h
#define ImpressionistDoc_h

#include "impressionist.h"
#include "bitmap.h"

class ImpressionistUI;

class ImpressionistDoc {
public:
	ImpressionistDoc();

	void	setUI(ImpressionistUI* ui);		// assign the UI produced by FLUID

	char*	getImageName();					// get the current image name
	
	int		loadImage(char *iname);			// called by the UI to load image
	int		saveImage(char *iname);			// called by the UI to save image

	void	setBrushType(int type);			// called by the UI to set the brushType
											// set the current brush to be the specified type

	int		getSize();						// get the UI size
	void	setSize(int size);				// set the UI size

// Attributes
public:
	int m_nWidth, m_nHeight;				// dimension of original window
	int m_nPaintWidth, m_nPaintHeight;		// dimension of the paint window
	unsigned char* m_ucBitmap;
	unsigned char* m_ucPainting;

	ImpBrush* m_pCurrentBrush;				// the current active brush

	int m_nSize;							// size of the brush

// Operations
public:
	GLubyte* GetOriginalPixel( int x, int y );		// get the color of the original picture
													// at the specified coord
	GLubyte* GetOriginalPixel( const Point p );		// get the color of the original picture
													// at the specified point

private:
	ImpressionistUI*	m_pUI;				

	char	m_imageName[256];

};

extern void MessageBox(char *message);

#endif
