//
// impressionistUI.h
//
// The header file for the UI part
//

#ifndef ImpressionistUI_h
#define ImpressionistUI_h

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/fl_file_chooser.H>		// FLTK file chooser
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Value_Slider.H>
#include <FL/Fl_Choice.H>

class impressionistDoc;
#include "originalview.h"
#include "paintview.h"

#include "ImpBrush.h"
#include "baseUI.h"


class ImpressionistUI : public BaseUI{

public:
	ImpressionistUI();

	// The FLTK widgets

	Fl_Menu_Bar*		m_menubar;
								
	Fl_Window*			m_brushDialog;
	Fl_Slider*			m_BrushSizeSlider;
	Fl_Choice*			m_BrushTypeChoice;

private:
	ImpressionistDoc*	m_pDoc;		// pointer to document to communicate with the document
	static ImpressionistUI* whoami(Fl_Menu_* o);
			
};

#endif
