//
// paintview.h
//
// The header file for painting view of the input images
//

#ifndef PAINTVIEW_H
#define PAINTVIEW_H

#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>
#include <FL/gl.h>
#include <GL/glu.h>
#include <stdlib.h>

class ImpressionistDoc;

class PaintView : public Fl_Gl_Window
{
public:
	PaintView(int x, int y, int w, int h, const char *l);
	void draw();
	int handle(int event);

	void refresh();
	
	void resizeWindow(int width, int height);

	void SaveCurrentContent();
	void RestoreContent();

	ImpressionistDoc *m_pDoc;

private:
	GLvoid* m_pPaintBitstart;
	int m_nDrawWidth, m_nDrawHeight;
	int m_nStartRow, m_nEndRow;
	int m_nStartCol, m_nEndCol;
	int m_nWindowWidth, m_nWindowHeight;
};

#endif